function Resource_Grid_GUI()
%RESOURCE_GRID_GUI This GUI displays the resource GRID for LTE SISO TM in
%FDD mode in downlink side. Normal Cyclic Prefix is assumed.
%% Define and initialize struct
regr = struct('chanBW', 6, 'nS', 0, 'contReg', 1);
%% Construct the components
f = figure('Visible','on','Name','GUI to plot Resource Grid','Position',[400,100,350,350]);
t_title = uicontrol(f, 'Style', 'text', 'String','Choose the desired parameters to display the resource Grid for different subframes',...
        'Position', [10 300 300 50]);     
t_chanBW = uicontrol(f, 'Style', 'text', 'String', 'Select channel bandwidth [MHz]',...
                    'Position', [50 250 100 50]);
e_chanBW = uicontrol(f,'Style','popupmenu', 'Callback', @select_chanBW,...
                    'String',{'1.4','3','5','10','15','20'},...
                    'Position',[50 200 100 50],'Tag','popumpmenu1');
t_nS =  uicontrol(f, 'Style', 'text', 'String', 'Select number of subframe',...
                    'Position', [50 150 100 50]);
e_nS = uicontrol(f,'Style','popupmenu', 'Callback', @select_nS,...
                    'String',{'0','5','Other'},...
                    'Position', [50 100 100 50]);
t_conReg =  uicontrol(f, 'Style', 'text', 'String', 'Select number of symbols to transmit control data',...
                    'Position', [50 50 100 50], 'Tag', 'pm_contReg');
e_contReg = uicontrol(f,'Style','popupmenu', 'Callback', @select_contReg,...
                    'String',{'1','2','3'},...
                    'Position', [50 0 100 50]);
push_regr = uicontrol(f, 'Style', 'pushbutton', 'Callback', @plot_regr,...
                'String', 'Start', 'Position',[175 50 100 100]); 
%% Write the callbacks
function select_chanBW(hObject, callbackdata)
chanString = hObject.String;
chanValue = hObject.Value;
    switch chanString{chanValue}
        case '1.4'
             regr.chanBW = 1;
             set(e_contReg,'String',{'2','3'});
        case '3'
             regr.chanBW = 2;
             set(e_contReg,'String',{'1','2','3'});
        case '5'
             regr.chanBW = 3;
             set(e_contReg,'String',{'1','2','3'});
        case '10'
             regr.chanBW = 4;
             set(e_contReg,'String',{'1','2','3'});
        case '15'
             regr.chanBW = 5;
             set(e_contReg,'String',{'1','2','3'});
        case '20'
             regr.chanBW = 6;
             set(e_contReg,'String',{'1','2','3'});
    end
end
function select_nS(hObject, callbackdata)
nS_String = hObject.String;
nS_Value = hObject.Value;
    switch nS_String{nS_Value}
        case '0'
             regr.nS = 0;  
        case '5'
             regr.nS = 5;
        case 'Other'
             regr.nS = 3; %Any value from 0 to 19 except 0 and 5.
    end    
end     
function select_contReg(hObject, callbackdata)
contReg_String = hObject.String;
contReg_Value = hObject.Value;
    switch contReg_String{contReg_Value}
        case '1'
             regr.contReg = 1;  
        case '2'
             regr.contReg = 2;
        case '3'
             regr.contReg = 3; 
    end    
end    
function plot_regr(hObject, callbackdata)
display (regr);
par = initialize_regr_par(regr);
%close
fh = figure()
Visualize_Grid(par);
end
end

