%% About
% This document contains the instructions to simulate the LTE Downlink SISO Transmission Mode 
% for different transmission chains by using LTE_SISO_GUI programmatic GUI. 
%% Scope
% The scope of this GUI is to provide users to study the LTE physical layer
% in downlink side without they have to know how works the transmission
% chain. Different transmission chains are provided in order to have a
% better comprehension about the different capabilities that offers LTE.
%% User Manual
% Open LTE_SISO_GUI.m and run it. A figure will be displayed. Select from
% it the desired transmission chain (in section TX_Chains each transmission
% chain is described)to simulate. Then select the following parameters:
    % Modulation type: QPSK, 16QAM, 64QAM.
    % SNR (Signal-to-Noise Ratio): in dB units.
    % Channel Bandwidth: 1.4,3,5,10,15,20 [MHz].
    % Equalization Mode: ZF (Zero Forcing) or MMSE (Mean Minimum Square Error)
    % Select channel type: 'flat-low-mobility', 'flat-high-mobility',...
    % 'frequency-selective-low-mobility','frequency-selective-high-mobility'[1].
% Also user can choose to display SPD and constellation diagram. Once all
% of these parameters are selected, simulation starts by pressing the star
% pushbutton. 
% At the end of the simulation BER value is displayed in command window.
%% TX_Chains
% There are 4 transmsission chains to choose from. Each of them are
% described below:
    % SISO_BASIC : Good enough to establish a link between tranmsitter and
    % receiver but with high BER values as there aren't any method to
    % estimate the channel.
    % SISO_PHASE_COMPENSATOR: Provides a method to compensate close echoes
    % due to the Rayleigh channel by cancelling phase term. Better improve
    % than SISO_BASIC, not quite good enough to provides a good enough BER
    % value.
    % SISO_CHANNEL_ESTIMATION: LTE specification provides a method to
    % estimate the channel response by the use of CSR signals. In this
    % method the receiver is modelated to estimate this 
%% Restrictions/Limitations for transmission chain
% Implementation according to LTTE release 8 (V8.8.0)
% Frame structure Type 1 : FDD mode
% Single codeword
% Only normal cyclic prefix is considered --> 7 symbols for slot 
% According to LTE specifications, when selected channel bandwidth is equal
% to 1.4[MHZ], contReg parameters should be one of these two values {2,3}.
% [1]When SISO_PHASE_COMPENSATOR transmission chain is selected, GUI automatically disable to select a 
% frequency-selective channel type.
%% Acknowledgements
% I have to mention 'Understanding LTE with MATLAB' book that had helped me to perform part of
% the transmission chain, above all transmission chain called SISO_COMPLETE. 


