function [d] = parameters(data)
%PARAMETERS Summary of this function goes here
%   Detailed explanation goes here
%Select transmission chain
d.txch = data.transmission_chain;
% PDSCH
d.numTx          = 1;    % Number of transmit antennas
d.numRx          = 1;    % Number of receive antennas
d.chanBW       = data.channelBW;    % Index to chanel bandwidth used [1,....6]
d.contReg       = 1;    % No. of OFDM symbols dedictaed to control information [1,...,3]
d.modType      = data.modulationType;   % Modulation type [1, 2, 3] for ['QPSK,'16QAM','64QAM']
% DLSCH
d.cRate            = 1/3; % Rate matching target coding rate 
d.maxIter         = 6;     % Maximum number of turbo decoding terations  
d.fullDecode    = 0;    % Whether "full" or "early stopping" turbo decoding is performed
% Channel model
d.chanMdl        =  data.channel_type; 
% Simulation parametrs
d.Eqmode        = data.Eqmode;      % Type of equalizer used [1,2] for ['ZF', 'MMSE']
d.chEstOn        = 1;     % Whether channel estimation is done or ideal channel model used
d.maxNumErrs = 1e6; % Maximum number of errors found before simulation stops
d.maxNumBits = 1e6;  % Maximum number of bits processed before simulation stops
d.snrdB            = data.SNR;   % Value of SNR used in this experiment
% Plot parameters
d.visualsOn = data.visualsOn; %Whether to visualize constellations and spectrum

end

