% Script for SISO_Basic
clear all
clear functions
disp('Simulating the LTE Mode 1: Single Tx and Rx antenna');
%% Create the parameter structures
commlteSISO_params;
[prmLTEPDSCH, prmLTEDLSCH, prmMdl] = commlteSISO_initialize( chanBW, contReg, modType,...
    cRate,maxIter, fullDecode, chanMdl, snrdB, maxNumErrs, maxNumBits);
clear  chanBW contReg numTx numRx modType cRate maxIter fullDecode chanMdl snrdB maxNumErrs maxNumBits;
tic;
    hPBer = comm.ErrorRate;
    snrdB = prmMdl.snrdBs;
    maxNumErrs=prmMdl.maxNumErrs;
    maxNumBits=prmMdl.maxNumBits;
    % Display data rate
    zReport_data_rate(prmLTEDLSCH, prmLTEPDSCH);
    %% Simulation loop
    nS = 0; % Slot number, one of [0:2:18]
    Measures = zeros(3,1); %initialize BER output
    while (( Measures(2)< maxNumErrs) && (Measures(3) < maxNumBits))
        [dataIn, dataOut, txSig, rxSig, dataRx, csr] = commlteSISO_step(nS, snrdB, prmLTEDLSCH, prmLTEPDSCH, prmMdl);
        % Calculate  bit errors
        Measures = step(hPBer, dataIn, dataOut); 
        % Visualize constellation & spectrum
        zVisualize(prmLTEPDSCH, txSig, rxSig, dataRx, csr, nS)
        % Update subframe number
        nS = nS + 2; if nS > 19, nS = mod(nS, 20); end;
    end
    ber=Measures(1); 
    disp(ber);
toc;