% Script for SISO_COMPLETE transmission chain
clear all
clear functions

%% Create the parameter structures
disp('Simulating the LTE SISO_COMPLETE transmission chain');
commlteSISO_params;
[prmLTEPDSCH, prmLTEDLSCH, prmMdl] = commlteSISO_initialize( chanBW, contReg, modType, Eqmode,...
    cRate,maxIter, fullDecode, chanMdl, maxNumErrs, maxNumBits);
clear  chanBW contReg numTx numRx modType Eqmode cRate maxIter fullDecode chanMdl maxNumErrs maxNumBits;
%%
zReport_data_rate(prmLTEDLSCH, prmLTEPDSCH);
tic;
    hPBer = comm.ErrorRate;
    maxNumErrs=prmMdl.maxNumErrs;
    maxNumBits=prmMdl.maxNumBits;
    %% Simulation loop
    nS = 0; % Slot number, one of [0:2:18]
    Measures = zeros(3,1); %initialize BER output
    while (( Measures(2)< maxNumErrs) && (Measures(3) < maxNumBits))
        [dataIn, dataOut, txSig, rxSig, dataRx, yRec, csr] = ...
            commlteSISO_step(nS, snrdB, prmLTEDLSCH, prmLTEPDSCH, prmMdl);
        % Calculate  bit errors
        Measures = step(hPBer, dataIn, dataOut);
        % Visualize constellations and spectrum
        if visualsOn
            zVisualize( prmLTEPDSCH, txSig, rxSig, yRec, dataRx, csr, nS);
        end;
        % Update subframe number
        nS = nS + 2; if nS > 19, nS = mod(nS, 20); end;
    end
    ber=Measures(1);
    disp(ber);
toc;
