function indices = lteIntrlvrIndices(blkLen)
%LTEINTRLVRINDICES Generate turbo code internal interleaver indices. 
%
%   INDICES = lteIntrlvrIndices(BLKLEN) returns the turbo code internal
%   interleaver indices for a specified block length, BLKLEN.
%   The format of the returned INDICES column vector is such that it can be
%   directly used as the parameter value in the general block interleaver.
%
%   See also getf1f2.

%#codegen

[f1, f2] = getf1f2(blkLen);
Idx      = (0:blkLen-1).';
indices  =  mod(f1*Idx + f2*Idx.^2, blkLen) + 1;

% [EOF]
