% Script for SISO_CHANNEL_ESTIMATION transmisssion chain
clear all
clear functions
disp('Simulating the LTE SISO_CHANNEL_ESTIMATION transmmission chain');
%% Create the parameter structures
commlteSISO_params;
[prmLTEPDSCH, prmLTEDLSCH, prmMdl] = commlteSISO_initialize( chanBW, contReg, modType,...
    cRate,maxIter, fullDecode, chanMdl, snrdB, est_mode, maxNumErrs, maxNumBits);
clear  chanBW contReg numTx numRx modType cRate maxIter fullDecode chanMdl snrdB est_mode maxNumErrs maxNumBits;
%%
zReport_data_rate(prmLTEDLSCH, prmLTEPDSCH);
% Enable if SNR swapping wants to be performed
% MaxIter=numel(prmMdl.snrdBs); 
% ber_vector=zeros(1,MaxIter); 
tic;
% Enable if SNR swapping wants to be performed
% for n=1:MaxIter 
    % Enable if SNR swapping wants to be performed
    % fprintf(1,'Iteration %2d out of %2d :\n', n, MaxIter);  %Enable if SNR swapping wants to be performed
    % snrdB = prmMdl.snrdBs(n); %Enable if SNR swapping wants to be performed
    % Disable if SNR swapping wants to be performed
    snrdB = prmMdl.snrdBs;
    % End of disable if SNR swapping wants to be performed
    hPBer = comm.ErrorRate;
    maxNumErrs=prmMdl.maxNumErrs;
    maxNumBits=prmMdl.maxNumBits;
    %% Simulation loop
    nS = 0; % Slot number, one of [0:2:18]
    Measures = zeros(3,1); %initialize BER output
    while (( Measures(2)< maxNumErrs) && (Measures(3) < maxNumBits))
        [dataIn, dataOut, txSig, rxSig, dataRx, yRec, csr] = ...
            commlteSISO_step(nS, snrdB, prmLTEDLSCH, prmLTEPDSCH, prmMdl);
        % Calculate  bit errors
        Measures = step(hPBer, dataIn, dataOut);
        % Visualize constellations and spectrum
        if visualsOn
            zVisualize( prmLTEPDSCH, txSig, rxSig, yRec, dataRx, csr, nS);
        end;
        % Update subframe number
        nS = nS + 2; if nS > 19, nS = mod(nS, 20); end;
    end
   ber=Measures(1); 
   % Disable if SNR swapping wants to be performed
   display(ber);  
   % Enable if SNR swapping wants to be performed
   % ber_vector(n)=ber; 
   % disp(ber_vector); 
toc;
% Enable if SNR swapping wants to be performed. Visualize BER vs SNR
% graphic
% semilogy(prmMdl.snrdBs, ber_vector); %Enable if SNR swapping wants to be performed
% title('BER - SNR');xlabel('SNR (dB)');ylabel('BER');grid; 
% legend('64QAM ,20MHz, Frequency-selective-high-mobility');
