% zREADME.m 
%% About
% This folder contains five different transmission chains about LTE DOWNLINK TRANSMISSION MODE(TM 1)
% For each transmission chain, there is a readme file where specific instructions to run its simulation 
% are provided.
%% Scope
% The scope of these transmissions chains is to study the LTE DOWNLINK TM1 system for
% each case. These study is carried out by displaying for each mode the
% constellation diagram & SPD (Spectral Power Density) for the most
% relevant signals. Also, at the end of the simulation the BER value is
% displayed.
%% Must be read!!
% In order to prevent unexpected errors while simulating, the user has to
% select one of the transmission chain and add it to the path. Once he/she
% is finished with this and wants to simulate another transmission chain,
% it's mandatory to remove firstly the transmission chain (that had just simulated) folder to the path.
% Then, selects another transmission chain and adds to path. And so on for each
% transmission chain change.
%% Common Instructions
% All the transmission chains follows the same structure:
% The main script is named commlteSISO_test_timing_ber or
% commlteSIMO_test_timing_ber. In this simulation is run.
% Also, it's possible to choose the simulation parameters by the script
% commlteSISO_params or commlteSISO_params. Although some parameters are
% common for all transmission chains, there are others that are specific to
% each specific transmission chain.
% Steps: 
    % 1: Open commlteSIXO_params.m and select parameters
    % 2: Open commlteSIXO_test_timing_ber.m and run script.
    % X in steps stands for S or M, depending on the transmission chain chosen.
% For better results, the experiments have to be performed with a large
% enough number of bits processed. On consequence, maxNumBits has to be larger 
% than 1e7 and maxNumErrs larger than 1e4 to get more exactly BER values.
% In spite of this, if constellation diagram and SPD want to be plotted but
% it's not prioritary to have an exactly BER (or you don't want to wait for
% a long) you can set maxNumBits within 1e6 and 2e6.
%% Limitations & Restriccions
% Based on 3GPP LTE release 8 (V8.8.0),  TS 36.212 and TS 36.211 documents
% of this version have looked up. Also, same documents for the release 10
% (V10.0.0) have been looked up in order as being release 10 the one which
% 'Understanding LTE with MATLAB' is based on.
% Single codeword
% FDD frame structure mode
% Full bandwidth
% Transmission Mode 1 (TM1)
% Normal cyclic prefix
% Single user
% When selected channel bandwidth is equal to 1.4 [MHz] it's possible to transmit
% only 1 ODFMA symbol for the PDCCH signal channels. In the specifications
% document you need, at least, two symbols. 
%% Acknowledgements
% I give my acknowledgments to the book 'Understanding LTE with MATLAB' writen by
% Houman Zarrinkoub, from MATHWORKS enterprise. In this book some parts of
% the code that I use are provided. This fact had helped the author to symplify his
% work. In spite of this, for each transmission chain some modifications
% have been carried out. Final code is more different from the original in SISO_BASIC,
% SISO_PHASE_COMPENSATOR and SISO_CHANNEL_COMPLETE than in SISO_COMPLETE
% and SIMO.
